diff --git a/usr/src/uts/common/io/cxgbe/t4nex/adapter.h b/usr/src/uts/common/io/cxgbe/t4nex/adapter.h
index ea147b19da..34659a32c6 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/adapter.h
+++ b/usr/src/uts/common/io/cxgbe/t4nex/adapter.h
@@ -326,137 +508,234 @@ struct sge_txq {
 	uint32_t txb_avail;	/* # of bytes available */
 	uint16_t copy_threshold; /* anything this size or less is copied up */
 
-	uint64_t txpkts;	/* # of ethernet packets */
-	uint64_t txbytes;	/* # of ethernet bytes */
 	kstat_t *ksp;
+	struct sge_txq_stats stats;
+};
 
+struct sge_rxq_stats {
 	/* stats for common events first */
-
-	uint64_t txcsum;	/* # of times hardware assisted with checksum */
-	uint64_t tso_wrs;	/* # of IPv4 TSO work requests */
-	uint64_t imm_wrs;	/* # of work requests with immediate data */
-	uint64_t sgl_wrs;	/* # of work requests with direct SGL */
-	uint64_t txpkt_wrs;	/* # of txpkt work requests (not coalesced) */
-	uint64_t txpkts_wrs;	/* # of coalesced tx work requests */
-	uint64_t txpkts_pkts;	/* # of frames in coalesced tx work requests */
-	uint64_t txb_used;	/* # of tx copy buffers used (64 byte each) */
-	uint64_t hdl_used;	/* # of DMA handles used */
-
-	/* stats for not-that-common events */
-
-	uint32_t txb_full;	/* txb ran out of space */
-	uint32_t dma_hdl_failed; /* couldn't obtain DMA handle */
-	uint32_t dma_map_failed; /* couldn't obtain DMA mapping */
-	uint32_t qfull;		/* out of hardware descriptors */
-	uint32_t pullup_early;	/* # of pullups before starting frame's SGL */
-	uint32_t pullup_late;	/* # of pullups while building frame's SGL */
-	uint32_t pullup_failed;	/* # of failed pullups */
-	uint32_t csum_failed;	/* # of csum reqs we failed to fulfill */
+	uint64_t rxcsum;	/* # of times hardware assisted with checksum */
+	uint64_t rxpkts;	/* # of ethernet packets */
+	uint64_t rxbytes;	/* # of ethernet bytes */
 };
 
-/* rxq: SGE ingress queue + SGE free list + miscellaneous items */
+/* Ethernet packet receive queue */
 struct sge_rxq {
-	struct sge_iq iq;	/* MUST be first */
-	struct sge_fl fl;
+	t4_sge_iq_t iq;
+	struct sge_fl fl;	/* Freelist for packet receive buffers */
 
-	struct port_info *port;	/* the port this rxq belongs to */
-	kstat_t *ksp;
+	struct port_info *port;
 
 	mac_ring_handle_t ring_handle;
 	uint64_t ring_gen_num;
 
-	/* stats for common events first */
+	kstat_t *ksp;
+	struct sge_rxq_stats stats;
+};
 
-	uint64_t rxcsum;	/* # of times hardware assisted with checksum */
-	uint64_t rxpkts;	/* # of ethernet packets */
-	uint64_t rxbytes;	/* # of ethernet bytes */
+typedef enum t4_port_flags {
+	TPF_INIT_DONE	= (1 << 0),
+	TPF_OPEN	= (1 << 1),
+	TPF_VI_ENABLED	= (1 << 2),
+} t4_port_flags_t;
 
-	/* stats for not-that-common events */
+typedef enum t4_port_feat {
+	CXGBE_HW_LSO	= (1 << 0),
+	CXGBE_HW_CSUM	= (1 << 1),
+} t4_port_feat_t;
+
+
+struct port_info {
+	kmutex_t	lock;
+	dev_info_t	*dip;
+	struct adapter	*adapter;
+	uint8_t		port_id;
+
+	t4_port_flags_t	flags;
+	t4_port_feat_t	features;
+
+	mac_handle_t	mh;
+	int		mtu;
+	uint8_t		hw_addr[ETHERADDRL];
+	int16_t 	xact_addr_filt; /* index of exact MAC address filter */
+
+	uint16_t	rxq_count;	/* # of RX queues */
+	uint16_t	rxq_start;	/* index of first RX queue */
+	uint16_t	txq_count;	/* # of TX queues */
+	uint16_t	txq_start;	/* index of first TX queue */
+
+	/*
+	 * Array of IQs for queue events, such as interrupt forward events
+	 * for Rx queue processing and completion events for Tx queues.
+	 * Only available when TIP_PER_PORT is selected. The size is based
+	 * on adapter.intr_queue_cfg.intr_per_port.
+	 */
+	t4_sge_iq_t	*intr_iqs;
+
+	kstat_t *ksp_config;
+	kstat_t *ksp_info;
+	kstat_t *ksp_fec;
+
+	/* Port attributes/data set by common code: */
+	uint16_t	viid;
+	uint16_t	rss_size;	/* size of VI's RSS table slice */
+
+	uint8_t		port_type;
+	int8_t		mdio_addr;
+	uint8_t		mod_type;
+
+	uint8_t		lport;
+	uint8_t		tx_chan;
+	uint8_t		rx_chan;
+	uint8_t		rx_cchan;
+
+	uint8_t		rss_mode;
+
+	uint8_t		tmr_idx;
+	int8_t		pktc_idx;
+	uint8_t		dbq_timer_idx;
 
-	uint32_t nomem;		/* mblk allocation during rx failed */
+	struct link_config link_cfg;
+	uint8_t		macaddr_cnt;
+
+	u8 vivld;
+	u8 vin;
+	u8 smt_idx;
+
+	/* Mirroring bits utilized by common code (unused by our driver) */
+	u16 viid_mirror;
+	u8 vivld_mirror;
+	u8 vin_mirror;
 };
 
-struct sge {
-	int fl_starve_threshold;
-	int s_qpp;
+struct sge_info {
+	uint_t fl_starve_threshold;
 	uint64_t dbq_timer_tick;
 	uint16_t dbq_timers[SGE_NDBQTIMERS];
 
-	int nrxq;	/* total rx queues (all ports and the rest) */
-	int ntxq;	/* total tx queues (all ports and the rest) */
-	int niq;	/* total ingress queues */
-	int neq;	/* total egress queues */
-	int stat_len;	/* length of status page at ring end */
-	int pktshift;	/* padding between CPL & packet data */
-	int fl_align;	/* response queue message alignment */
+	uint_t eq_spg_len;	/* EQ status page length in host credits */
+	uint_t pktshift;	/* padding between CPL & packet data */
+	uint_t fl_align;	/* response queue message alignment */
 	uint8_t fwq_tmr_idx;	/* Intr. coalesce timer for FWQ */
 	int8_t fwq_pktc_idx;	/* Intr. coalesce count for FWQ */
 
-	struct sge_iq fwq;	/* Firmware event queue */
-	struct sge_txq *txq;	/* NIC tx queues */
-	struct sge_rxq *rxq;	/* NIC rx queues */
+	t4_sge_iq_t fwq;	/* Firmware event queue */
 
-	uint_t iq_start; /* iq context id map start index */
-	uint_t eq_start; /* eq context id map start index */
-	uint_t iqmap_sz; /* size of iq context id map */
-	uint_t eqmap_sz; /* size of eq context id map */
-	struct sge_iq **iqmap;	/* iq->cntxt_id to iq mapping */
-	struct sge_eq **eqmap;	/* eq->cntxt_id to eq mapping */
+	uint_t rxq_count;	/* total RX queues (all ports and the rest) */
+	uint_t txq_count;	/* total TX queues (all ports and the rest) */
+	struct sge_txq *txq;	/* NIC TX queues */
+	struct sge_rxq *rxq;	/* NIC RX queues */
+
+	/*
+	 * Adapters uses 16-bit "context IDs" to uniquely identify queues.
+	 *
+	 * References to the queues, indexed by said context IDs are maintained
+	 * here, using the start/end values queried from the adapter.
+	 */
+	uint_t iqmap_start;	/* IQ context id map start index */
+	uint_t rxqmap_start;	/* IQ context id map start index */
+	uint_t eqmap_start;	/* EQ context id map start index */
+	uint_t iqmap_sz;	/* size of IQ context id map */
+	uint_t eqmap_sz;	/* size of EQ context id map */
+	t4_sge_iq_t **iqmap;	/* iq->cntxt_id to IQ mapping */
+	t4_sge_eq_t **eqmap;	/* eq->cntxt_id to EQ mapping */
 
 	/* Device access and DMA attributes for all the descriptor rings */
 	ddi_device_acc_attr_t acc_attr_desc;
 	ddi_dma_attr_t	dma_attr_desc;
 
-	/* Device access and DMA attributes for tx buffers */
+	/* Device access and DMA attributes for TX buffers */
 	ddi_device_acc_attr_t acc_attr_tx;
 	ddi_dma_attr_t	dma_attr_tx;
 
-	/* Device access and DMA attributes for rx buffers are in rxb_params */
+	/* Device access and DMA attributes for RX buffers are in rxb_params */
 	kmem_cache_t *rxbuf_cache;
 	struct rxbuf_cache_params rxb_params;
 };
 
 struct driver_properties {
-	int max_ntxq_10g;
-	int max_nrxq_10g;
-	int max_ntxq_1g;
-	int max_nrxq_1g;
-	int intr_types;
-	int tmr_idx_10g;
-	int pktc_idx_10g;
-	int tmr_idx_1g;
-	int pktc_idx_1g;
+	uint8_t ethq_tmr_idx;
+	int8_t ethq_pktc_idx;
 	uint8_t dbq_timer_idx;
 	uint8_t fwq_tmr_idx;
 	int8_t fwq_pktc_idx;
-	int qsize_txq;
-	int qsize_rxq;
+	uint16_t qsize_txq;
+	uint16_t qsize_rxq;
 
 	uint_t holdoff_timer_us[SGE_NTIMERS];
 	uint_t holdoff_pktcnt[SGE_NCOUNTERS];
 
-	int wc;
-
-	int multi_rings;
+	bool write_combine;
 	int t4_fw_install;
 };
 
-struct t4_mbox_list {
-	STAILQ_ENTRY(t4_mbox_list) link;
-};
+typedef struct t4_mbox_waiter {
+	list_node_t node;
+	kthread_t *thread;
+} t4_mbox_waiter_t;
 
 typedef enum t4_adapter_flags {
 	/* Initialization progress status bits */
 	TAF_INIT_DONE	= (1 << 0),
 	TAF_FW_OK	= (1 << 1),
-	TAF_INTR_FWD	= (1 << 2),
-	TAF_INTR_ALLOC	= (1 << 3),
+	TAF_INTR_ALLOC	= (1 << 2),
 
 	/* State & capability bits */
-	TAF_MASTER_PF	= (1 << 4),
-	TAF_DBQ_TIMER	= (1 << 5),
+	TAF_MASTER_PF	= (1 << 8),
+	TAF_DBQ_TIMER	= (1 << 9),
 } t4_adapter_flags_t;
 
+/* Plan for interrupt allocation */
+typedef enum t4_intr_plan {
+	/* Everything on a single interrupt */
+	TIP_SINGLE,
+	/* One for device errors, one FWQ (including forwarded intrs) */
+	TIP_ERR_QUEUES,
+	/* 1 + 1 for errors and FWQ, with rest divided evenly between ports */
+	TIP_PER_PORT,
+} t4_intr_plan_t;
+
+struct t4_intrs_queues {
+	/* The DDI_INTR_TYPE_* value negotiated. */
+	int intr_type;
+
+	/*
+	 * The plan for interrupt allocation, based on the interrupt type
+	 * and number of interrupts available. See the block comment in
+	 * t4_nexus.c for more information.
+	 */
+	t4_intr_plan_t intr_plan;
+
+	/*
+	 * The number of interrupts available (intr_avail) for use vs. the
+	 * number of interrupts the driver has decided to make use of
+	 * (intr_count). These values may be different depending on the
+	 * number available and the port count of the attached part.
+	 */
+	int intr_avail;
+	int intr_count;
+
+	/*
+	 * The number of interrupts per port for use with event queues.
+	 * These interrupts are used to take delivery of Tx recycling
+	 * messages and Rx packet delivery.
+	 */
+	uint_t intr_per_port;
+
+	/*
+	 * Track the number of IQs allocated for use with interrupts. We track
+	 * this to know how many IQs we have leftover for Rx queue usage.
+	 */
+	uint_t num_iqs;
+
+	/* The maximum number of RX/TX queues per port. */
+	uint_t port_max_rxq;
+	uint_t port_max_txq;
+};
+
+/*
+ * WO - Write Once at initialization time.
+ */
 struct adapter {
 	list_node_t node;
 	dev_info_t *dip;
@@ -483,17 +762,15 @@ struct adapter {
 	caddr_t bar2_ptr;
 
 	/* Interrupt information */
-	int intr_type;
-	int intr_count;
+	ddi_intr_handle_t *intr_handle;
 	int intr_cap;
 	uint_t intr_pri;
-	ddi_intr_handle_t *intr_handle;
 
 	struct driver_properties props;
 	kstat_t *ksp;
 	kstat_t *ksp_stat;
 
-	struct sge sge;
+	struct sge_info sge;
 
 	struct port_info *port[MAX_NPORTS];
 	uint8_t chan_map[NCHAN];
@@ -504,13 +781,19 @@ struct adapter {
 
 	unsigned int cfcsum;
 	struct adapter_params params;
+	struct t4_intrs_queues intr_queue_cfg;
 
 	kmutex_t lock;
 	kcondvar_t cv;
 
-	/* Starving free lists */
-	kmutex_t sfl_lock;	/* same cache-line as sc_lock? but that's ok */
-	TAILQ_HEAD(, sge_fl) sfl;
+	/*
+	 * Starving freelist state
+	 *
+	 * sfl_lock protects the `sfl_flags` and `sfl_node` fields in all sge_fl
+	 * structs owned by this adapter.
+	 */
+	kmutex_t sfl_lock;
+	list_t sfl_list;
 	timeout_id_t sfl_timer;
 
 	/* Sensors */
@@ -521,12 +804,8 @@ struct adapter {
 
 	/* support for single-threading access to adapter mailbox registers */
 	kmutex_t mbox_lock;
-	STAILQ_HEAD(, t4_mbox_list) mbox_list;
-};
-
-struct memwin {
-	uint32_t base;
-	uint32_t aperture;
+	kcondvar_t mbox_cv;
+	list_t mbox_list;
 };
 
 #define	ADAPTER_LOCK(sc)		mutex_enter(&(sc)->lock)
@@ -539,30 +818,21 @@ struct memwin {
 #define	PORT_LOCK_ASSERT_OWNED(pi)	ASSERT(mutex_owned(&(pi)->lock))
 #define	PORT_LOCK_ASSERT_NOTOWNED(pi)	ASSERT(!mutex_owned(&(pi)->lock))
 
-#define	IQ_LOCK(iq)			mutex_enter(&(iq)->lock)
-#define	IQ_UNLOCK(iq)			mutex_exit(&(iq)->lock)
-#define	IQ_LOCK_ASSERT_OWNED(iq)	ASSERT(mutex_owned(&(iq)->lock))
-#define	IQ_LOCK_ASSERT_NOTOWNED(iq)	ASSERT(!mutex_owned(&(iq)->lock))
-
-#define	FL_LOCK(fl)			mutex_enter(&(fl)->lock)
-#define	FL_UNLOCK(fl)			mutex_exit(&(fl)->lock)
-#define	FL_LOCK_ASSERT_OWNED(fl)	ASSERT(mutex_owned(&(fl)->lock))
-#define	FL_LOCK_ASSERT_NOTOWNED(fl)	ASSERT(!mutex_owned(&(fl)->lock))
+#define	IQ_LOCK(iq)			mutex_enter(&(iq)->tsi_lock)
+#define	IQ_UNLOCK(iq)			mutex_exit(&(iq)->tsi_lock)
+#define	IQ_LOCK_ASSERT_OWNED(iq)	ASSERT(mutex_owned(&(iq)->tsi_lock))
+#define	IQ_LOCK_ASSERT_NOTOWNED(iq)	ASSERT(!mutex_owned(&(iq)->tsi_lock))
 
-#define	RXQ_LOCK(rxq)			IQ_LOCK(&(rxq)->iq)
-#define	RXQ_UNLOCK(rxq)			IQ_UNLOCK(&(rxq)->iq)
-#define	RXQ_LOCK_ASSERT_OWNED(rxq)	IQ_LOCK_ASSERT_OWNED(&(rxq)->iq)
-#define	RXQ_LOCK_ASSERT_NOTOWNED(rxq)	IQ_LOCK_ASSERT_NOTOWNED(&(rxq)->iq)
+#define	EQ_LOCK(eq)			mutex_enter(&(eq)->tse_lock)
+#define	EQ_UNLOCK(eq)			mutex_exit(&(eq)->tse_lock)
+#define	EQ_LOCK_ASSERT_OWNED(eq)	ASSERT(mutex_owned(&(eq)->tse_lock))
+#define	EQ_LOCK_ASSERT_NOTOWNED(eq)	ASSERT(!mutex_owned(&(eq)->tse_lock))
 
-#define	RXQ_FL_LOCK(rxq)		FL_LOCK(&(rxq)->fl)
-#define	RXQ_FL_UNLOCK(rxq)		FL_UNLOCK(&(rxq)->fl)
-#define	RXQ_FL_LOCK_ASSERT_OWNED(rxq)	FL_LOCK_ASSERT_OWNED(&(rxq)->fl)
-#define	RXQ_FL_LOCK_ASSERT_NOTOWNED(rxq) FL_LOCK_ASSERT_NOTOWNED(&(rxq)->fl)
-
-#define	EQ_LOCK(eq)			mutex_enter(&(eq)->lock)
-#define	EQ_UNLOCK(eq)			mutex_exit(&(eq)->lock)
-#define	EQ_LOCK_ASSERT_OWNED(eq)	ASSERT(mutex_owned(&(eq)->lock))
-#define	EQ_LOCK_ASSERT_NOTOWNED(eq)	ASSERT(!mutex_owned(&(eq)->lock))
+/* Freelist state is protected by its EQ lock */
+#define	FL_LOCK(fl)			EQ_LOCK(&(fl)->eq)
+#define	FL_UNLOCK(fl)			EQ_UNLOCK(&(fl)->eq)
+#define	FL_LOCK_ASSERT_OWNED(fl)	EQ_LOCK_ASSERT_OWNED(&(fl)->eq)
+#define	FL_LOCK_ASSERT_NOTOWNED(fl)	EQ_LOCK_ASSERT_NOTOWNED(&(fl)->eq)
 
 #define	TXQ_LOCK(txq)			EQ_LOCK(&(txq)->eq)
 #define	TXQ_UNLOCK(txq)			EQ_UNLOCK(&(txq)->eq)
@@ -570,38 +840,11 @@ struct memwin {
 #define	TXQ_LOCK_ASSERT_NOTOWNED(txq)	EQ_LOCK_ASSERT_NOTOWNED(&(txq)->eq)
 
 #define	for_each_txq(pi, iter, txq) \
-	txq = &pi->adapter->sge.txq[pi->first_txq]; \
-	for (iter = 0; iter < pi->ntxq; ++iter, ++txq)
+	txq = &pi->adapter->sge.txq[pi->txq_start]; \
+	for (iter = 0; iter < pi->txq_count; ++iter, ++txq)
 #define	for_each_rxq(pi, iter, rxq) \
-	rxq = &pi->adapter->sge.rxq[pi->first_rxq]; \
-	for (iter = 0; iter < pi->nrxq; ++iter, ++rxq)
-
-#define	NFIQ(sc) ((sc)->intr_count > 1 ? (sc)->intr_count - 1 : 1)
-
-/* One for errors, one for firmware events */
-#define	T4_EXTRA_INTR 2
-
-static inline void t4_mbox_list_add(struct adapter *adap,
-				    struct t4_mbox_list *entry)
-{
-	mutex_enter(&adap->mbox_lock);
-	STAILQ_INSERT_TAIL(&adap->mbox_list, entry, link);
-	mutex_exit(&adap->mbox_lock);
-}
-
-static inline void t4_mbox_list_del(struct adapter *adap,
-				    struct t4_mbox_list *entry)
-{
-	mutex_enter(&adap->mbox_lock);
-	STAILQ_REMOVE(&adap->mbox_list, entry, t4_mbox_list, link);
-	mutex_exit(&adap->mbox_lock);
-}
-
-static inline struct t4_mbox_list *
-t4_mbox_list_first_entry(struct adapter *adap)
-{
-	return (STAILQ_FIRST(&adap->mbox_list));
-}
+	rxq = &pi->adapter->sge.rxq[pi->rxq_start]; \
+	for (iter = 0; iter < pi->rxq_count; ++iter, ++rxq)
 
 static inline struct port_info *
 adap2pinfo(struct adapter *sc, int idx)
@@ -609,28 +852,9 @@ adap2pinfo(struct adapter *sc, int idx)
 	return (sc->port[idx]);
 }
 
-static inline struct sge_rxq *
-iq_to_rxq(struct sge_iq *iq)
-{
-	return (__containerof(iq, struct sge_rxq, iq));
-}
-
-static inline bool
-t4_port_is_10xg(const struct port_info *pi)
-{
-	return (pi->link_cfg.pcaps &
-	    (FW_PORT_CAP32_SPEED_400G |
-	    FW_PORT_CAP32_SPEED_200G |
-	    FW_PORT_CAP32_SPEED_100G |
-	    FW_PORT_CAP32_SPEED_50G |
-	    FW_PORT_CAP32_SPEED_40G |
-	    FW_PORT_CAP32_SPEED_25G |
-	    FW_PORT_CAP32_SPEED_10G));
-}
-
 static inline unsigned int t4_use_ldst(struct adapter *adap)
 {
-	return (adap->flags & FW_OK);
+	return (adap->flags & TAF_FW_OK);
 }
 
 static inline void t4_db_full(struct adapter *adap) {}
@@ -652,46 +876,50 @@ t4_cver_ge(const adapter_t *adap, uint8_t ver)
 
 /* t4_nexus.c */
 int t4_port_full_init(struct port_info *);
-void t4_port_queues_enable(struct port_info *pi);
-void t4_port_queues_disable(struct port_info *pi);
 
 uint32_t t4_read_reg(struct adapter *, uint32_t);
 void t4_write_reg(struct adapter *, uint32_t, uint32_t);
 uint64_t t4_read_reg64(struct adapter *, uint32_t);
 void t4_write_reg64(struct adapter *, uint32_t, uint64_t);
 
+void t4_mbox_waiter_add(struct adapter *, t4_mbox_waiter_t *);
+void t4_mbox_waiter_remove(struct adapter *, t4_mbox_waiter_t *);
+bool t4_mbox_wait_owner(struct adapter *, uint_t, bool);
+
 /* t4_debug.c */
 void t4_debug_init(void);
 void t4_debug_fini(void);
 
 /* t4_sge.c */
-void t4_sge_init(struct adapter *sc);
-int t4_alloc_fwq(struct adapter *);
-int t4_free_fwq(struct adapter *);
-int t4_setup_port_queues(struct port_info *pi);
-int t4_teardown_port_queues(struct port_info *pi);
-uint_t t4_intr_all(caddr_t arg1, caddr_t arg2);
-uint_t t4_intr(caddr_t arg1, caddr_t arg2);
-uint_t t4_intr_err(caddr_t arg1, caddr_t arg2);
-void t4_iq_gts_update(struct sge_iq *, t4_intr_config_t, uint16_t);
-void t4_iq_update_intr_cfg(struct sge_iq *, uint8_t, int8_t);
-void t4_eq_update_dbq_timer(struct sge_eq *, struct port_info *);
-int t4_mgmt_tx(struct adapter *sc, mblk_t *m);
+void t4_sge_init(struct adapter *);
+int t4_alloc_evt_iqs(struct adapter *);
+void t4_free_evt_iqs(struct adapter *);
+void t4_port_kstats_init(struct port_info *);
+void t4_port_kstats_fini(struct port_info *);
+int t4_port_queues_init(struct port_info *);
+void t4_port_queues_fini(struct port_info *);
+void t4_port_queues_enable(struct port_info *pi);
+void t4_port_queues_disable(struct port_info *pi);
+uint_t t4_intr_all(caddr_t, caddr_t);
+uint_t t4_intr_err(caddr_t, caddr_t);
+uint_t t4_intr_fwq(caddr_t, caddr_t);
+uint_t t4_intr_port_queue(caddr_t, caddr_t);
+void t4_iq_gts_update(t4_sge_iq_t *, t4_gts_config_t, uint16_t);
+void t4_iq_update_intr_cfg(t4_sge_iq_t *, uint8_t, int8_t);
+void t4_eq_update_dbq_timer(t4_sge_eq_t *, struct port_info *);
 
 mblk_t *t4_eth_tx(void *, mblk_t *);
-mblk_t *t4_mc_tx(void *arg, mblk_t *m);
-mblk_t *t4_ring_rx(struct sge_rxq *rxq, int poll_bytes);
+t4_iq_result_t t4_process_rx_iq(t4_sge_iq_t *, uint_t, struct t4_poll_req *);
 
 /* t4_mac.c */
-void t4_mc_cb_init(struct port_info *);
 void t4_os_link_changed(struct adapter *sc, int idx, int link_stat);
-void t4_mac_rx(struct port_info *pi, struct sge_rxq *rxq, mblk_t *m);
 void t4_mac_tx_update(struct port_info *pi, struct sge_txq *txq);
 int t4_addmac(void *arg, const uint8_t *ucaddr);
 const char **t4_get_priv_props(struct port_info *, size_t *);
 uint8_t t4_choose_holdoff_timer(struct adapter *, uint_t);
 int8_t t4_choose_holdoff_pktcnt(struct adapter *, int);
 uint_t t4_choose_dbq_timer(struct adapter *, uint_t);
+extern mac_callbacks_t t4_mac_callbacks;
 
 /* t4_ioctl.c */
 int t4_ioctl(struct adapter *sc, int cmd, void *data, int mode);
diff --git a/usr/src/uts/common/io/cxgbe/t4nex/cudbg.h b/usr/src/uts/common/io/cxgbe/t4nex/cudbg.h
index e86de21085..64cdbedd93 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/cudbg.h
+++ b/usr/src/uts/common/io/cxgbe/t4nex/cudbg.h
@@ -318,7 +318,7 @@ static struct el ATTRIBUTE_UNUSED entity_list[] = {
 };
 
 #ifdef _KERNEL
-typedef int (*cudbg_print_cb) (dev_info_t *dip, int, char *, ...);
+typedef void (*cudbg_print_cb) (dev_info_t *dip, int, char *, ...);
 #else
 typedef int (*cudbg_print_cb) (char *, ...);
 #endif
diff --git a/usr/src/uts/common/io/cxgbe/t4nex/cudbg_lib.c b/usr/src/uts/common/io/cxgbe/t4nex/cudbg_lib.c
index e6b5b16667..1b1caa64f5 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/cudbg_lib.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/cudbg_lib.c
@@ -3389,7 +3389,7 @@ collect_tid(struct cudbg_init *pdbg_init,
 	rc = compress_buff(&scratch_buff, dbg_buff);
 
 err1:
-	ADAPTER_UNLOCK(padap);
+	ADAPTER_LOCK(padap);
 	release_scratch_buff(&scratch_buff, dbg_buff);
 err:
 	return rc;
diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_ioctl.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_ioctl.c
index 6ca43b52b9..4263ad691d 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_ioctl.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_ioctl.c
@@ -22,7 +22,6 @@
 
 #include <sys/ddi.h>
 #include <sys/sunddi.h>
-#include <sys/queue.h>
 
 #include "t4nex.h"
 #include "common/common.h"
